SystemOrganization addCategory: #PacMan!

TestCase subclass: #PacManTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PacMan'!

!PacManTest methodsFor: 'actors' stamp: 'IgalFrid 5/16/2012 19:32'!
blueGhost

	^BlueGhost new.! !

!PacManTest methodsFor: 'movements' stamp: 'IgalFrid 5/16/2012 19:38'!
down

	^Down new! !

!PacManTest methodsFor: 'construction block types' stamp: 'IgalFrid 5/16/2012 20:38'!
ghostHouseDoorType

	^GhostHouseDoorType new! !

!PacManTest methodsFor: 'movements' stamp: 'IgalFrid 5/16/2012 19:38'!
left

	^Left new! !

!PacManTest methodsFor: 'construction block types' stamp: 'IgalFrid 5/16/2012 20:44'!
leftTransporterType

	^LeftTransporterType new! !

!PacManTest methodsFor: 'actors' stamp: 'IgalFrid 5/16/2012 19:53'!
pacman

	^Pacman new! !

!PacManTest methodsFor: 'movements' stamp: 'IgalFrid 5/16/2012 19:38'!
right

	^Right new! !

!PacManTest methodsFor: 'construction block types' stamp: 'IgalFrid 5/16/2012 19:59'!
spaceType

	^SpaceType new
! !

!PacManTest methodsFor: 'tests' stamp: 'HernanWilkinson 5/16/2012 16:31'!
test01GhostCanNotGoIntoAWall

	self assert: self blueGhost position equals: ( self wallType nextPositionFor: self blueGhost going: self left ).
	self assert: self blueGhost position equals: ( self wallType nextPositionFor: self blueGhost going: self right ).
	self assert: self blueGhost position equals: ( self wallType nextPositionFor: self blueGhost going: self up ).
	self assert: self blueGhost position equals: ( self wallType nextPositionFor: self blueGhost going: self down ).
! !

!PacManTest methodsFor: 'tests' stamp: 'HernanWilkinson 5/16/2012 16:31'!
test02PacmanCanNotGoIntoAWall

	self assert: self pacman position equals: ( self wallType nextPositionFor: self pacman going: self left ).
	self assert: self pacman position equals: ( self wallType nextPositionFor: self pacman going: self right ).
	self assert: self pacman position equals: ( self wallType nextPositionFor: self pacman going: self up ).
	self assert: self pacman position equals: ( self wallType nextPositionFor: self pacman going: self down ).
! !

!PacManTest methodsFor: 'tests' stamp: 'HernanWilkinson 5/16/2012 16:31'!
test03GhostMovesIntoSpaces

	self assert: ( self blueGhost position + (-1@0) ) equals: ( self spaceType nextPositionFor: self blueGhost going: self left ).
	self assert: ( self blueGhost position +  (1@0) ) equals: ( self spaceType nextPositionFor: self blueGhost going: self right ).
	self assert: ( self blueGhost position +  (0@1) ) equals: ( self spaceType nextPositionFor: self blueGhost going: self up ).
	self assert: ( self blueGhost position + (0@ -1) ) equals: ( self spaceType nextPositionFor: self blueGhost going: self down ).
! !

!PacManTest methodsFor: 'tests' stamp: 'HernanWilkinson 5/16/2012 16:31'!
test04PacmanMovesIntoSpaces

	self assert: ( self pacman position + (-1@0) ) equals: ( self spaceType nextPositionFor: self pacman going: self left ).
	self assert: ( self pacman position +  (1@0) ) equals: ( self spaceType nextPositionFor: self pacman going: self right ).
	self assert: ( self pacman position +  (0@1) ) equals: ( self spaceType nextPositionFor: self pacman going: self up ).
	self assert: ( self pacman position + (0@ -1) ) equals: ( self spaceType nextPositionFor: self pacman going: self down ).

! !

!PacManTest methodsFor: 'tests' stamp: 'HernanWilkinson 5/16/2012 16:30'!
test05GhostCanEnterHisHouse

	self assert: ( self blueGhost position + (-1@0) ) equals: (self ghostHouseDoorType nextPositionFor: self blueGhost going: self left).
	self assert: ( self blueGhost position +  (1@0) ) equals: (self ghostHouseDoorType nextPositionFor: self blueGhost going: self right ).
	self assert: ( self blueGhost position +  (0@1) ) equals: (self ghostHouseDoorType nextPositionFor: self blueGhost going: self up ).
	self assert: ( self blueGhost position + (0@ -1) ) equals: (self ghostHouseDoorType nextPositionFor: self blueGhost going: self down ).
! !

!PacManTest methodsFor: 'tests' stamp: 'HernanWilkinson 5/16/2012 16:30'!
test06PacmanCanNotEnterGhostHouse

	self assert: self pacman position equals: ( self ghostHouseDoorType nextPositionFor: self pacman going: self left ).
	self assert: self pacman position equals: ( self ghostHouseDoorType nextPositionFor: self pacman going: self right ).
	self assert: self pacman position equals: ( self ghostHouseDoorType nextPositionFor: self pacman going: self up ).
	self assert: self pacman position equals: ( self ghostHouseDoorType nextPositionFor: self pacman going: self down ).
! !

!PacManTest methodsFor: 'tests' stamp: 'HernanWilkinson 5/16/2012 16:30'!
test07GhostCanNotGoIntoTransporter

	self assert: self blueGhost position equals: ( self leftTransporterType nextPositionFor: self blueGhost going: self left ).
	self assert: self blueGhost position equals: ( self leftTransporterType nextPositionFor: self blueGhost going: self right ).
! !

!PacManTest methodsFor: 'tests' stamp: 'HernanWilkinson 5/16/2012 16:30'!
test08TransporterMovesPacmanToNewPosition

	self assert: (3@10) equals: ( self leftTransporterType nextPositionFor: self pacman going: self left ).
	self assert: (3@10) equals: ( self leftTransporterType nextPositionFor: self pacman going: self right ).
! !

!PacManTest methodsFor: 'movements' stamp: 'IgalFrid 5/16/2012 19:39'!
up

	^Up new! !

!PacManTest methodsFor: 'construction block types' stamp: 'IgalFrid 5/16/2012 19:35'!
wallType

	^WallType new.! !

Object subclass: #Actor
	instanceVariableNames: 'position'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PacMan'!

!Actor methodsFor: 'as yet unclassified' stamp: 'IgalFrid 5/16/2012 20:49'!
initialize
	
	position := (0@0)! !

!Actor methodsFor: 'as yet unclassified' stamp: 'IgalFrid 5/16/2012 20:19'!
position
	
	^position! !

Actor subclass: #BlueGhost
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PacMan'!

!BlueGhost methodsFor: 'as yet unclassified' stamp: 'IgalFrid 5/16/2012 21:15'!
type
	
	^#Ghost! !

Actor subclass: #Pacman
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PacMan'!

!Pacman methodsFor: 'as yet unclassified' stamp: 'IgalFrid 5/16/2012 21:15'!
type
	
	^#Pacman! !

Object subclass: #Direction
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PacMan'!

Direction subclass: #Down
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PacMan'!

!Down methodsFor: 'as yet unclassified' stamp: 'IgalFrid 5/16/2012 20:32'!
initialize
	^(0@ -1)! !

Direction subclass: #Left
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PacMan'!

!Left methodsFor: 'as yet unclassified' stamp: 'IgalFrid 5/16/2012 20:33'!
initialize
	^(-1@0)! !

Direction subclass: #Right
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PacMan'!

!Right methodsFor: 'as yet unclassified' stamp: 'IgalFrid 5/16/2012 20:33'!
initialize
	^(1@0)! !

Direction subclass: #Up
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PacMan'!

!Up methodsFor: 'as yet unclassified' stamp: 'IgalFrid 5/16/2012 20:33'!
initialize
	^(0@1)! !

Object subclass: #FieldType
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PacMan'!

!FieldType methodsFor: 'as yet unclassified' stamp: 'IgalFrid 5/16/2012 20:50'!
nextPositionFor: anActor going: aDirection
	
	self subclassResponsibility ! !

FieldType subclass: #GhostHouseDoorType
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PacMan'!

!GhostHouseDoorType methodsFor: 'as yet unclassified' stamp: 'IgalFrid 5/16/2012 21:14'!
nextPositionFor: anActor going: aDirection
	
	(anActor isKindOf: BlueGhost) ifTrue: [^anActor position + aDirection].
	^anActor position.
	! !

FieldType subclass: #LeftTransporterType
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PacMan'!

!LeftTransporterType methodsFor: 'as yet unclassified' stamp: 'IgalFrid 5/16/2012 20:52'!
nextPositionFor: anActor going: aDirection
	
	(anActor isKindOf: Pacman) ifTrue: [^(3@10)].
	^anActor position ! !

FieldType subclass: #SpaceType
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PacMan'!

!SpaceType methodsFor: 'as yet unclassified' stamp: 'IgalFrid 5/16/2012 20:31'!
nextPositionFor: anActor going: aDirection
	
	^anActor position + aDirection ! !

FieldType subclass: #WallType
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PacMan'!

!WallType methodsFor: 'as yet unclassified' stamp: 'IgalFrid 5/16/2012 20:28'!
nextPositionFor: anActor going: aDirection
	
	^anActor position! !
